using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using PaintDotNet.Effects;
using PaintDotNet;

namespace GraphMaker
{
  public class EffectPluginConfigDialog : PaintDotNet.Effects.EffectConfigDialog
  {
    private Button buttonOK;
    private TrackBar sSquaresX;
    private TrackBar sSquaresY;
    private Label label2;
    private Label label3;
    private NumericUpDown udSquaresX;
    private NumericUpDown udSquaresY;
    private CheckBox cbHVLinked;
    private GroupBox groupBox1;
    private RadioButton rbChecker;
    private RadioButton rbGrid;
    private RadioButton rbDots;
    private PictureBox pictureBox1;
    private PictureBox pictureBox2;
    private CheckBox cbAlpha;
    private CheckBox cbForeGround;
    private CheckBox cbSwap;
    private CheckBox cbUseBW;
    private CheckBox cbVari;
    private Label label1;
    private Label label4;
    private GroupBox groupBox2;
    private PictureBox pictureBox6;
    private RadioButton rbDrawBR;
    private PictureBox pictureBox5;
    private RadioButton rbDrawCS;
    private PictureBox pictureBox4;
    private RadioButton rbDrawCC;
    private PictureBox pictureBox3;
    private RadioButton rbDrawTL;
    private LinkLabel linkLabel1;
    private PictureBox pictureBox7;
	private NumericUpDown udYMajor;
	private NumericUpDown udXMajor;
	private Label label5;
	private Label label6;
    private Button buttonCancel;

    public EffectPluginConfigDialog()
    {
      InitializeComponent();
    }

    protected override void InitialInitToken()
    {
      theEffectToken = new EffectPluginConfigToken();
    }

    protected override void InitTokenFromDialog()
    {
      // This saves all the UI controls into the token variables
      ((EffectPluginConfigToken)EffectToken).XSquares = (int)udSquaresX.Value;
	  ((EffectPluginConfigToken)EffectToken).YSquares = (int)udSquaresY.Value;
	  ((EffectPluginConfigToken)EffectToken).XMajor = (int)udXMajor.Value;
	  ((EffectPluginConfigToken)EffectToken).YMajor = (int)udYMajor.Value;
      ((EffectPluginConfigToken)EffectToken).Type = 0;
      if (rbChecker.Checked) ((EffectPluginConfigToken)EffectToken).Type = 1;
      if (rbDots.Checked) ((EffectPluginConfigToken)EffectToken).Type = 2;
      ((EffectPluginConfigToken)EffectToken).DrawMode = 0;
      if (rbDrawCC.Checked) ((EffectPluginConfigToken)EffectToken).DrawMode = 1;
      else if (rbDrawCS.Checked) ((EffectPluginConfigToken)EffectToken).DrawMode = 2;
      else if (rbDrawTL.Checked) ((EffectPluginConfigToken)EffectToken).DrawMode = 3;
      ((EffectPluginConfigToken)EffectToken).Alpha = cbAlpha.Checked;
      ((EffectPluginConfigToken)EffectToken).KeepBG = cbForeGround.Checked;
      ((EffectPluginConfigToken)EffectToken).Invert = cbSwap.Checked;
      ((EffectPluginConfigToken)EffectToken).UseBrushWidth = cbUseBW.Checked;
      ((EffectPluginConfigToken)EffectToken).UseVariation = cbVari.Checked;
      ((EffectPluginConfigToken)EffectToken).Linked = cbHVLinked.Checked;
    }

	protected override void InitDialogFromToken(EffectConfigToken effectToken)
	{
		// This repopulates the UI when you run the effect a second time
		EffectPluginConfigToken token = (EffectPluginConfigToken)effectToken;
		cbAlpha.Checked = token.Alpha;
		cbForeGround.Checked = token.KeepBG;
		cbSwap.Checked = token.Invert;
		cbUseBW.Checked = token.UseBrushWidth;
		cbVari.Checked = token.UseVariation;
		udSquaresY.Value = (decimal)token.YSquares;
		sSquaresY.Value = (int)udSquaresY.Value;
		udSquaresX.Value = (decimal)token.XSquares;
		sSquaresX.Value = (int)udSquaresX.Value;
		udXMajor.Value = (decimal)token.XMajor;
		udYMajor.Value = (decimal)token.YMajor;
		cbHVLinked.Checked = token.Linked;
		if (token.Type == 0) rbGrid.Checked = true;
		if (token.Type == 1) rbChecker.Checked = true;
		if (token.Type == 2) rbDots.Checked = true;
		if (token.DrawMode == 0) rbDrawTL.Checked = true;
		if (token.DrawMode == 1) rbDrawCC.Checked = true;
		if (token.DrawMode == 2) rbDrawCS.Checked = true;
		if (token.DrawMode == 3) rbDrawBR.Checked = true;
	}

    private void InitializeComponent()
    {
		this.buttonCancel = new System.Windows.Forms.Button();
		this.buttonOK = new System.Windows.Forms.Button();
		this.sSquaresX = new System.Windows.Forms.TrackBar();
		this.sSquaresY = new System.Windows.Forms.TrackBar();
		this.label2 = new System.Windows.Forms.Label();
		this.label3 = new System.Windows.Forms.Label();
		this.udSquaresX = new System.Windows.Forms.NumericUpDown();
		this.udSquaresY = new System.Windows.Forms.NumericUpDown();
		this.cbHVLinked = new System.Windows.Forms.CheckBox();
		this.groupBox1 = new System.Windows.Forms.GroupBox();
		this.pictureBox7 = new System.Windows.Forms.PictureBox();
		this.rbDots = new System.Windows.Forms.RadioButton();
		this.pictureBox2 = new System.Windows.Forms.PictureBox();
		this.pictureBox1 = new System.Windows.Forms.PictureBox();
		this.cbVari = new System.Windows.Forms.CheckBox();
		this.rbChecker = new System.Windows.Forms.RadioButton();
		this.rbGrid = new System.Windows.Forms.RadioButton();
		this.cbAlpha = new System.Windows.Forms.CheckBox();
		this.cbForeGround = new System.Windows.Forms.CheckBox();
		this.cbSwap = new System.Windows.Forms.CheckBox();
		this.cbUseBW = new System.Windows.Forms.CheckBox();
		this.label1 = new System.Windows.Forms.Label();
		this.label4 = new System.Windows.Forms.Label();
		this.groupBox2 = new System.Windows.Forms.GroupBox();
		this.pictureBox6 = new System.Windows.Forms.PictureBox();
		this.rbDrawBR = new System.Windows.Forms.RadioButton();
		this.pictureBox5 = new System.Windows.Forms.PictureBox();
		this.rbDrawCS = new System.Windows.Forms.RadioButton();
		this.pictureBox4 = new System.Windows.Forms.PictureBox();
		this.rbDrawCC = new System.Windows.Forms.RadioButton();
		this.pictureBox3 = new System.Windows.Forms.PictureBox();
		this.rbDrawTL = new System.Windows.Forms.RadioButton();
		this.linkLabel1 = new System.Windows.Forms.LinkLabel();
		this.udYMajor = new System.Windows.Forms.NumericUpDown();
		this.udXMajor = new System.Windows.Forms.NumericUpDown();
		this.label5 = new System.Windows.Forms.Label();
		this.label6 = new System.Windows.Forms.Label();
		((System.ComponentModel.ISupportInitialize)(this.sSquaresX)).BeginInit();
		((System.ComponentModel.ISupportInitialize)(this.sSquaresY)).BeginInit();
		((System.ComponentModel.ISupportInitialize)(this.udSquaresX)).BeginInit();
		((System.ComponentModel.ISupportInitialize)(this.udSquaresY)).BeginInit();
		this.groupBox1.SuspendLayout();
		((System.ComponentModel.ISupportInitialize)(this.pictureBox7)).BeginInit();
		((System.ComponentModel.ISupportInitialize)(this.pictureBox2)).BeginInit();
		((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
		this.groupBox2.SuspendLayout();
		((System.ComponentModel.ISupportInitialize)(this.pictureBox6)).BeginInit();
		((System.ComponentModel.ISupportInitialize)(this.pictureBox5)).BeginInit();
		((System.ComponentModel.ISupportInitialize)(this.pictureBox4)).BeginInit();
		((System.ComponentModel.ISupportInitialize)(this.pictureBox3)).BeginInit();
		((System.ComponentModel.ISupportInitialize)(this.udYMajor)).BeginInit();
		((System.ComponentModel.ISupportInitialize)(this.udXMajor)).BeginInit();
		this.SuspendLayout();
		// 
		// buttonCancel
		// 
		this.buttonCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
		this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
		this.buttonCancel.Location = new System.Drawing.Point(257, 337);
		this.buttonCancel.Name = "buttonCancel";
		this.buttonCancel.Size = new System.Drawing.Size(75, 23);
		this.buttonCancel.TabIndex = 21;
		this.buttonCancel.Text = "Cancel";
		this.buttonCancel.UseVisualStyleBackColor = true;
		this.buttonCancel.Click += new System.EventHandler(this.buttonCancel_Click);
		// 
		// buttonOK
		// 
		this.buttonOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
		this.buttonOK.Location = new System.Drawing.Point(176, 337);
		this.buttonOK.Name = "buttonOK";
		this.buttonOK.Size = new System.Drawing.Size(75, 23);
		this.buttonOK.TabIndex = 20;
		this.buttonOK.Text = "OK";
		this.buttonOK.UseVisualStyleBackColor = true;
		this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
		// 
		// sSquaresX
		// 
		this.sSquaresX.LargeChange = 10;
		this.sSquaresX.Location = new System.Drawing.Point(6, 25);
		this.sSquaresX.Maximum = 300;
		this.sSquaresX.Minimum = 1;
		this.sSquaresX.Name = "sSquaresX";
		this.sSquaresX.Size = new System.Drawing.Size(148, 45);
		this.sSquaresX.TabIndex = 2;
		this.sSquaresX.TickFrequency = 30;
		this.sSquaresX.Value = 10;
		this.sSquaresX.Scroll += new System.EventHandler(this.sGridStepX_Scroll);
		// 
		// sSquaresY
		// 
		this.sSquaresY.LargeChange = 10;
		this.sSquaresY.Location = new System.Drawing.Point(6, 91);
		this.sSquaresY.Maximum = 300;
		this.sSquaresY.Minimum = 1;
		this.sSquaresY.Name = "sSquaresY";
		this.sSquaresY.Size = new System.Drawing.Size(148, 45);
		this.sSquaresY.TabIndex = 7;
		this.sSquaresY.TickFrequency = 30;
		this.sSquaresY.Value = 10;
		this.sSquaresY.Scroll += new System.EventHandler(this.sGridStepY_Scroll);
		// 
		// label2
		// 
		this.label2.AutoSize = true;
		this.label2.Location = new System.Drawing.Point(6, 7);
		this.label2.Name = "label2";
		this.label2.Size = new System.Drawing.Size(96, 13);
		this.label2.TabIndex = 1;
		this.label2.Text = "Horizontal Squares";
		// 
		// label3
		// 
		this.label3.AutoSize = true;
		this.label3.Location = new System.Drawing.Point(6, 73);
		this.label3.Name = "label3";
		this.label3.Size = new System.Drawing.Size(84, 13);
		this.label3.TabIndex = 6;
		this.label3.Text = "Vertical Squares";
		// 
		// udSquaresX
		// 
		this.udSquaresX.Location = new System.Drawing.Point(156, 27);
		this.udSquaresX.Maximum = new decimal(new int[] {
            300,
            0,
            0,
            0});
		this.udSquaresX.Minimum = new decimal(new int[] {
            1,
            0,
            0,
            0});
		this.udSquaresX.Name = "udSquaresX";
		this.udSquaresX.Size = new System.Drawing.Size(49, 20);
		this.udSquaresX.TabIndex = 3;
		this.udSquaresX.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
		this.udSquaresX.Value = new decimal(new int[] {
            10,
            0,
            0,
            0});
		this.udSquaresX.ValueChanged += new System.EventHandler(this.udGridStepX_ValueChanged);
		// 
		// udSquaresY
		// 
		this.udSquaresY.Location = new System.Drawing.Point(156, 92);
		this.udSquaresY.Maximum = new decimal(new int[] {
            300,
            0,
            0,
            0});
		this.udSquaresY.Minimum = new decimal(new int[] {
            1,
            0,
            0,
            0});
		this.udSquaresY.Name = "udSquaresY";
		this.udSquaresY.Size = new System.Drawing.Size(49, 20);
		this.udSquaresY.TabIndex = 8;
		this.udSquaresY.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
		this.udSquaresY.Value = new decimal(new int[] {
            10,
            0,
            0,
            0});
		this.udSquaresY.ValueChanged += new System.EventHandler(this.udGridStepY_ValueChanged);
		// 
		// cbHVLinked
		// 
		this.cbHVLinked.AutoSize = true;
		this.cbHVLinked.Checked = true;
		this.cbHVLinked.CheckState = System.Windows.Forms.CheckState.Checked;
		this.cbHVLinked.Location = new System.Drawing.Point(112, 73);
		this.cbHVLinked.Name = "cbHVLinked";
		this.cbHVLinked.Size = new System.Drawing.Size(126, 17);
		this.cbHVLinked.TabIndex = 9;
		this.cbHVLinked.Text = "linked with Horizontal";
		this.cbHVLinked.UseVisualStyleBackColor = true;
		this.cbHVLinked.CheckedChanged += new System.EventHandler(this.cbHVLinked_CheckedChanged);
		// 
		// groupBox1
		// 
		this.groupBox1.Controls.Add(this.pictureBox7);
		this.groupBox1.Controls.Add(this.rbDots);
		this.groupBox1.Controls.Add(this.pictureBox2);
		this.groupBox1.Controls.Add(this.pictureBox1);
		this.groupBox1.Controls.Add(this.cbVari);
		this.groupBox1.Controls.Add(this.rbChecker);
		this.groupBox1.Controls.Add(this.rbGrid);
		this.groupBox1.Location = new System.Drawing.Point(9, 138);
		this.groupBox1.Name = "groupBox1";
		this.groupBox1.Size = new System.Drawing.Size(145, 116);
		this.groupBox1.TabIndex = 13;
		this.groupBox1.TabStop = false;
		this.groupBox1.Text = "Mode";
		// 
		// pictureBox7
		// 
		this.pictureBox7.Image = global::GraphMaker.Properties.Resources.modeD;
		this.pictureBox7.Location = new System.Drawing.Point(7, 67);
		this.pictureBox7.Name = "pictureBox7";
		this.pictureBox7.Size = new System.Drawing.Size(16, 16);
		this.pictureBox7.TabIndex = 21;
		this.pictureBox7.TabStop = false;
		// 
		// rbDots
		// 
		this.rbDots.AutoSize = true;
		this.rbDots.Enabled = false;
		this.rbDots.Location = new System.Drawing.Point(32, 66);
		this.rbDots.Name = "rbDots";
		this.rbDots.Size = new System.Drawing.Size(78, 17);
		this.rbDots.TabIndex = 2;
		this.rbDots.Text = "Dots in grid";
		this.rbDots.UseVisualStyleBackColor = true;
		this.rbDots.CheckedChanged += new System.EventHandler(this.rbDots_CheckedChanged);
		// 
		// pictureBox2
		// 
		this.pictureBox2.Image = global::GraphMaker.Properties.Resources.modeC;
		this.pictureBox2.Location = new System.Drawing.Point(7, 44);
		this.pictureBox2.Name = "pictureBox2";
		this.pictureBox2.Size = new System.Drawing.Size(16, 16);
		this.pictureBox2.TabIndex = 19;
		this.pictureBox2.TabStop = false;
		// 
		// pictureBox1
		// 
		this.pictureBox1.Image = global::GraphMaker.Properties.Resources.modeG;
		this.pictureBox1.Location = new System.Drawing.Point(7, 21);
		this.pictureBox1.Name = "pictureBox1";
		this.pictureBox1.Size = new System.Drawing.Size(16, 16);
		this.pictureBox1.TabIndex = 18;
		this.pictureBox1.TabStop = false;
		// 
		// cbVari
		// 
		this.cbVari.AutoSize = true;
		this.cbVari.Location = new System.Drawing.Point(52, 89);
		this.cbVari.Name = "cbVari";
		this.cbVari.Size = new System.Drawing.Size(67, 17);
		this.cbVari.TabIndex = 3;
		this.cbVari.Text = "Variation";
		this.cbVari.UseVisualStyleBackColor = true;
		this.cbVari.CheckedChanged += new System.EventHandler(this.cbVari_CheckedChanged);
		// 
		// rbChecker
		// 
		this.rbChecker.AutoSize = true;
		this.rbChecker.Location = new System.Drawing.Point(32, 43);
		this.rbChecker.Name = "rbChecker";
		this.rbChecker.Size = new System.Drawing.Size(96, 17);
		this.rbChecker.TabIndex = 1;
		this.rbChecker.Text = "Checker Board";
		this.rbChecker.UseVisualStyleBackColor = true;
		this.rbChecker.CheckedChanged += new System.EventHandler(this.rbChecker_CheckedChanged);
		// 
		// rbGrid
		// 
		this.rbGrid.AutoSize = true;
		this.rbGrid.Checked = true;
		this.rbGrid.Location = new System.Drawing.Point(32, 20);
		this.rbGrid.Name = "rbGrid";
		this.rbGrid.Size = new System.Drawing.Size(72, 17);
		this.rbGrid.TabIndex = 0;
		this.rbGrid.TabStop = true;
		this.rbGrid.Text = "Grid Lines";
		this.rbGrid.UseVisualStyleBackColor = true;
		this.rbGrid.CheckedChanged += new System.EventHandler(this.rbGrid_CheckedChanged);
		// 
		// cbAlpha
		// 
		this.cbAlpha.AutoSize = true;
		this.cbAlpha.Location = new System.Drawing.Point(16, 268);
		this.cbAlpha.Name = "cbAlpha";
		this.cbAlpha.Size = new System.Drawing.Size(75, 17);
		this.cbAlpha.TabIndex = 15;
		this.cbAlpha.Text = "Alpha only";
		this.cbAlpha.UseVisualStyleBackColor = true;
		this.cbAlpha.CheckedChanged += new System.EventHandler(this.cbAlpha_CheckedChanged);
		// 
		// cbForeGround
		// 
		this.cbForeGround.AutoSize = true;
		this.cbForeGround.Location = new System.Drawing.Point(16, 291);
		this.cbForeGround.Name = "cbForeGround";
		this.cbForeGround.Size = new System.Drawing.Size(102, 17);
		this.cbForeGround.TabIndex = 16;
		this.cbForeGround.Text = "Foreground only";
		this.cbForeGround.UseVisualStyleBackColor = true;
		this.cbForeGround.CheckedChanged += new System.EventHandler(this.cbForeGround_CheckedChanged);
		// 
		// cbSwap
		// 
		this.cbSwap.AutoSize = true;
		this.cbSwap.Location = new System.Drawing.Point(16, 314);
		this.cbSwap.Name = "cbSwap";
		this.cbSwap.Size = new System.Drawing.Size(84, 17);
		this.cbSwap.TabIndex = 17;
		this.cbSwap.Text = "Swap colors";
		this.cbSwap.UseVisualStyleBackColor = true;
		this.cbSwap.CheckedChanged += new System.EventHandler(this.cbSwap_CheckedChanged);
		// 
		// cbUseBW
		// 
		this.cbUseBW.AutoSize = true;
		this.cbUseBW.Location = new System.Drawing.Point(16, 337);
		this.cbUseBW.Name = "cbUseBW";
		this.cbUseBW.Size = new System.Drawing.Size(103, 17);
		this.cbUseBW.TabIndex = 18;
		this.cbUseBW.Text = "Use Brush width";
		this.cbUseBW.UseVisualStyleBackColor = true;
		this.cbUseBW.CheckedChanged += new System.EventHandler(this.cbUseBW_CheckedChanged);
		// 
		// label1
		// 
		this.label1.AutoSize = true;
		this.label1.Location = new System.Drawing.Point(171, 50);
		this.label1.Name = "label1";
		this.label1.Size = new System.Drawing.Size(34, 13);
		this.label1.TabIndex = 21;
		this.label1.Text = "1-300";
		this.label1.TextAlign = System.Drawing.ContentAlignment.TopRight;
		// 
		// label4
		// 
		this.label4.AutoSize = true;
		this.label4.Location = new System.Drawing.Point(171, 115);
		this.label4.Name = "label4";
		this.label4.Size = new System.Drawing.Size(34, 13);
		this.label4.TabIndex = 12;
		this.label4.Text = "1-300";
		this.label4.TextAlign = System.Drawing.ContentAlignment.TopRight;
		// 
		// groupBox2
		// 
		this.groupBox2.Controls.Add(this.pictureBox6);
		this.groupBox2.Controls.Add(this.rbDrawBR);
		this.groupBox2.Controls.Add(this.pictureBox5);
		this.groupBox2.Controls.Add(this.rbDrawCS);
		this.groupBox2.Controls.Add(this.pictureBox4);
		this.groupBox2.Controls.Add(this.rbDrawCC);
		this.groupBox2.Controls.Add(this.pictureBox3);
		this.groupBox2.Controls.Add(this.rbDrawTL);
		this.groupBox2.Enabled = false;
		this.groupBox2.Location = new System.Drawing.Point(160, 138);
		this.groupBox2.Name = "groupBox2";
		this.groupBox2.Size = new System.Drawing.Size(174, 116);
		this.groupBox2.TabIndex = 14;
		this.groupBox2.TabStop = false;
		this.groupBox2.Text = "Drawing position";
		// 
		// pictureBox6
		// 
		this.pictureBox6.Image = global::GraphMaker.Properties.Resources.gridBR;
		this.pictureBox6.Location = new System.Drawing.Point(10, 91);
		this.pictureBox6.Name = "pictureBox6";
		this.pictureBox6.Size = new System.Drawing.Size(16, 16);
		this.pictureBox6.TabIndex = 26;
		this.pictureBox6.TabStop = false;
		// 
		// rbDrawBR
		// 
		this.rbDrawBR.AutoSize = true;
		this.rbDrawBR.Location = new System.Drawing.Point(35, 90);
		this.rbDrawBR.Name = "rbDrawBR";
		this.rbDrawBR.Size = new System.Drawing.Size(86, 17);
		this.rbDrawBR.TabIndex = 3;
		this.rbDrawBR.Text = "Bottom Right";
		this.rbDrawBR.UseVisualStyleBackColor = true;
		this.rbDrawBR.CheckedChanged += new System.EventHandler(this.rbDrawBR_CheckedChanged);
		// 
		// pictureBox5
		// 
		this.pictureBox5.Image = global::GraphMaker.Properties.Resources.gridCS;
		this.pictureBox5.Location = new System.Drawing.Point(10, 68);
		this.pictureBox5.Name = "pictureBox5";
		this.pictureBox5.Size = new System.Drawing.Size(16, 16);
		this.pictureBox5.TabIndex = 24;
		this.pictureBox5.TabStop = false;
		// 
		// rbDrawCS
		// 
		this.rbDrawCS.AutoSize = true;
		this.rbDrawCS.Location = new System.Drawing.Point(35, 67);
		this.rbDrawCS.Name = "rbDrawCS";
		this.rbDrawCS.Size = new System.Drawing.Size(121, 17);
		this.rbDrawCS.TabIndex = 2;
		this.rbDrawCS.Text = "Centered on surface";
		this.rbDrawCS.UseVisualStyleBackColor = true;
		this.rbDrawCS.CheckedChanged += new System.EventHandler(this.rbDrawCS_CheckedChanged);
		// 
		// pictureBox4
		// 
		this.pictureBox4.Image = global::GraphMaker.Properties.Resources.gridCC;
		this.pictureBox4.Location = new System.Drawing.Point(10, 45);
		this.pictureBox4.Name = "pictureBox4";
		this.pictureBox4.Size = new System.Drawing.Size(16, 16);
		this.pictureBox4.TabIndex = 22;
		this.pictureBox4.TabStop = false;
		// 
		// rbDrawCC
		// 
		this.rbDrawCC.AutoSize = true;
		this.rbDrawCC.Location = new System.Drawing.Point(35, 44);
		this.rbDrawCC.Name = "rbDrawCC";
		this.rbDrawCC.Size = new System.Drawing.Size(125, 17);
		this.rbDrawCC.TabIndex = 1;
		this.rbDrawCC.Text = "Centered on crossing";
		this.rbDrawCC.UseVisualStyleBackColor = true;
		this.rbDrawCC.CheckedChanged += new System.EventHandler(this.rbDrawCC_CheckedChanged);
		// 
		// pictureBox3
		// 
		this.pictureBox3.Image = global::GraphMaker.Properties.Resources.gridTL;
		this.pictureBox3.Location = new System.Drawing.Point(10, 22);
		this.pictureBox3.Name = "pictureBox3";
		this.pictureBox3.Size = new System.Drawing.Size(16, 16);
		this.pictureBox3.TabIndex = 20;
		this.pictureBox3.TabStop = false;
		// 
		// rbDrawTL
		// 
		this.rbDrawTL.AutoSize = true;
		this.rbDrawTL.Checked = true;
		this.rbDrawTL.Location = new System.Drawing.Point(35, 21);
		this.rbDrawTL.Name = "rbDrawTL";
		this.rbDrawTL.Size = new System.Drawing.Size(65, 17);
		this.rbDrawTL.TabIndex = 0;
		this.rbDrawTL.TabStop = true;
		this.rbDrawTL.Text = "Top Left";
		this.rbDrawTL.UseVisualStyleBackColor = true;
		// 
		// linkLabel1
		// 
		this.linkLabel1.AutoSize = true;
		this.linkLabel1.Location = new System.Drawing.Point(215, 273);
		this.linkLabel1.Name = "linkLabel1";
		this.linkLabel1.Size = new System.Drawing.Size(101, 13);
		this.linkLabel1.TabIndex = 19;
		this.linkLabel1.TabStop = true;
		this.linkLabel1.Text = "Need more plugins?";
		this.linkLabel1.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel1_LinkClicked);
		// 
		// udYMajor
		// 
		this.udYMajor.Location = new System.Drawing.Point(283, 92);
		this.udYMajor.Maximum = new decimal(new int[] {
            300,
            0,
            0,
            0});
		this.udYMajor.Name = "udYMajor";
		this.udYMajor.Size = new System.Drawing.Size(49, 20);
		this.udYMajor.TabIndex = 11;
		this.udYMajor.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
		this.udYMajor.Value = new decimal(new int[] {
            5,
            0,
            0,
            0});
		this.udYMajor.ValueChanged += new System.EventHandler(this.udYMajor_ValueChanged);
		// 
		// udXMajor
		// 
		this.udXMajor.Location = new System.Drawing.Point(283, 27);
		this.udXMajor.Maximum = new decimal(new int[] {
            300,
            0,
            0,
            0});
		this.udXMajor.Name = "udXMajor";
		this.udXMajor.Size = new System.Drawing.Size(49, 20);
		this.udXMajor.TabIndex = 5;
		this.udXMajor.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
		this.udXMajor.Value = new decimal(new int[] {
            5,
            0,
            0,
            0});
		this.udXMajor.ValueChanged += new System.EventHandler(this.udXMajor_ValueChanged);
		// 
		// label5
		// 
		this.label5.AutoSize = true;
		this.label5.Location = new System.Drawing.Point(252, 7);
		this.label5.Name = "label5";
		this.label5.Size = new System.Drawing.Size(80, 13);
		this.label5.TabIndex = 4;
		this.label5.Text = "Marker spacing";
		// 
		// label6
		// 
		this.label6.AutoSize = true;
		this.label6.Location = new System.Drawing.Point(254, 73);
		this.label6.Name = "label6";
		this.label6.Size = new System.Drawing.Size(80, 13);
		this.label6.TabIndex = 10;
		this.label6.Text = "Marker spacing";
		// 
		// EffectPluginConfigDialog
		// 
		this.AutoScaleDimensions = new System.Drawing.SizeF(96F, 96F);
		this.CancelButton = this.buttonCancel;
		this.ClientSize = new System.Drawing.Size(344, 372);
		this.ControlBox = false;
		this.Controls.Add(this.label6);
		this.Controls.Add(this.label5);
		this.Controls.Add(this.udYMajor);
		this.Controls.Add(this.udXMajor);
		this.Controls.Add(this.linkLabel1);
		this.Controls.Add(this.groupBox2);
		this.Controls.Add(this.label4);
		this.Controls.Add(this.label1);
		this.Controls.Add(this.cbUseBW);
		this.Controls.Add(this.cbSwap);
		this.Controls.Add(this.cbForeGround);
		this.Controls.Add(this.cbAlpha);
		this.Controls.Add(this.groupBox1);
		this.Controls.Add(this.buttonCancel);
		this.Controls.Add(this.udSquaresY);
		this.Controls.Add(this.cbHVLinked);
		this.Controls.Add(this.udSquaresX);
		this.Controls.Add(this.label3);
		this.Controls.Add(this.label2);
		this.Controls.Add(this.sSquaresY);
		this.Controls.Add(this.sSquaresX);
		this.Controls.Add(this.buttonOK);
		this.Name = "EffectPluginConfigDialog";
		this.Text = "Grid /CheckerBoard Maker";
		this.Controls.SetChildIndex(this.buttonOK, 0);
		this.Controls.SetChildIndex(this.sSquaresX, 0);
		this.Controls.SetChildIndex(this.sSquaresY, 0);
		this.Controls.SetChildIndex(this.label2, 0);
		this.Controls.SetChildIndex(this.label3, 0);
		this.Controls.SetChildIndex(this.udSquaresX, 0);
		this.Controls.SetChildIndex(this.cbHVLinked, 0);
		this.Controls.SetChildIndex(this.udSquaresY, 0);
		this.Controls.SetChildIndex(this.buttonCancel, 0);
		this.Controls.SetChildIndex(this.groupBox1, 0);
		this.Controls.SetChildIndex(this.cbAlpha, 0);
		this.Controls.SetChildIndex(this.cbForeGround, 0);
		this.Controls.SetChildIndex(this.cbSwap, 0);
		this.Controls.SetChildIndex(this.cbUseBW, 0);
		this.Controls.SetChildIndex(this.label1, 0);
		this.Controls.SetChildIndex(this.label4, 0);
		this.Controls.SetChildIndex(this.groupBox2, 0);
		this.Controls.SetChildIndex(this.linkLabel1, 0);
		this.Controls.SetChildIndex(this.udXMajor, 0);
		this.Controls.SetChildIndex(this.udYMajor, 0);
		this.Controls.SetChildIndex(this.label5, 0);
		this.Controls.SetChildIndex(this.label6, 0);
		((System.ComponentModel.ISupportInitialize)(this.sSquaresX)).EndInit();
		((System.ComponentModel.ISupportInitialize)(this.sSquaresY)).EndInit();
		((System.ComponentModel.ISupportInitialize)(this.udSquaresX)).EndInit();
		((System.ComponentModel.ISupportInitialize)(this.udSquaresY)).EndInit();
		this.groupBox1.ResumeLayout(false);
		this.groupBox1.PerformLayout();
		((System.ComponentModel.ISupportInitialize)(this.pictureBox7)).EndInit();
		((System.ComponentModel.ISupportInitialize)(this.pictureBox2)).EndInit();
		((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
		this.groupBox2.ResumeLayout(false);
		this.groupBox2.PerformLayout();
		((System.ComponentModel.ISupportInitialize)(this.pictureBox6)).EndInit();
		((System.ComponentModel.ISupportInitialize)(this.pictureBox5)).EndInit();
		((System.ComponentModel.ISupportInitialize)(this.pictureBox4)).EndInit();
		((System.ComponentModel.ISupportInitialize)(this.pictureBox3)).EndInit();
		((System.ComponentModel.ISupportInitialize)(this.udYMajor)).EndInit();
		((System.ComponentModel.ISupportInitialize)(this.udXMajor)).EndInit();
		this.ResumeLayout(false);
		this.PerformLayout();

    }

    private void buttonOK_Click(object sender, EventArgs e)
    {
      FinishTokenUpdate();
      DialogResult = DialogResult.OK;
      this.Close();
    }

    private void buttonCancel_Click(object sender, EventArgs e)
    {
      this.Close();
    }

    private void sGridStepX_Scroll(object sender, EventArgs e)
    {
      if (sSquaresX.Value != udSquaresX.Value)
      {
        udSquaresX.Value = sSquaresX.Value;
        cbHVLinked_CopyVal(true);
        Update();
      }
      FinishTokenUpdate();
    }

    private void sGridStepY_Scroll(object sender, EventArgs e)
    {
      if (sSquaresY.Value != udSquaresY.Value)
      {
        udSquaresY.Value = sSquaresY.Value;
        cbHVLinked_CopyVal(false);
        Update();
      }
      FinishTokenUpdate();
    }

    private void udGridStepX_ValueChanged(object sender, EventArgs e)
    {
      if (sSquaresX.Value != (int)udSquaresX.Value)
      {
        sSquaresX.Value = (int)udSquaresX.Value;
        cbHVLinked_CopyVal(true);
        Update();
        FinishTokenUpdate();
      }

    }

    private void udGridStepY_ValueChanged(object sender, EventArgs e)
    {
      if (sSquaresY.Value != (int)udSquaresY.Value)
      {
        sSquaresY.Value = (int)udSquaresY.Value;
        cbHVLinked_CopyVal(false);
        Update();
        FinishTokenUpdate();
      }
    }

    private void cbHVLinked_CheckedChanged(object sender, EventArgs e)
    {
      cbHVLinked_CopyVal(true);
      FinishTokenUpdate();
    }

	private void cbHVLinked_CopyVal(bool XY)
	{
		if (cbHVLinked.Checked)
		{
			if (XY)
			{
				sSquaresY.Value = sSquaresX.Value;
				udSquaresY.Value = sSquaresY.Value;
				udYMajor.Value = udXMajor.Value;
			}
			else
			{
				sSquaresX.Value = sSquaresY.Value;
				udSquaresX.Value = sSquaresX.Value;
				udXMajor.Value = udYMajor.Value;
			}
		}
	}

    private void rbGrid_CheckedChanged(object sender, EventArgs e)
    {
      FinishTokenUpdate();
    }

    private void rbChecker_CheckedChanged(object sender, EventArgs e)
    {
      FinishTokenUpdate();
    }

    private void rbDrawCC_CheckedChanged(object sender, EventArgs e)
    {
      FinishTokenUpdate();
    }

    private void rbDrawCS_CheckedChanged(object sender, EventArgs e)
    {
      FinishTokenUpdate();
    }

    private void rbDrawBR_CheckedChanged(object sender, EventArgs e)
    {
      FinishTokenUpdate();
    }
    private void rbDots_CheckedChanged(object sender, EventArgs e)
    {
      FinishTokenUpdate();
    }

    private void cbAlpha_CheckedChanged(object sender, EventArgs e)
    {
      FinishTokenUpdate();
    }

    private void cbForeGround_CheckedChanged(object sender, EventArgs e)
    {
      FinishTokenUpdate();
    }

    private void cbSwap_CheckedChanged(object sender, EventArgs e)
    {
      FinishTokenUpdate();
    }

    private void cbUseBW_CheckedChanged(object sender, EventArgs e)
    {
      FinishTokenUpdate();
    }

    private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
    {
      PdnInfo.OpenUrl(this, "http://www.getpaint.net/redirect/plugins.html");
    }

    private void cbVari_CheckedChanged(object sender, EventArgs e)
    {
      FinishTokenUpdate();
    }

	private void udXMajor_ValueChanged(object sender, EventArgs e)
	{
		cbHVLinked_CopyVal(true);
		FinishTokenUpdate();
	}

	private void udYMajor_ValueChanged(object sender, EventArgs e)
	{
		cbHVLinked_CopyVal(false);
		FinishTokenUpdate();
	}
  }
}