using System;

namespace GraphMaker
{
	public class EffectPluginConfigToken : PaintDotNet.Effects.EffectConfigToken
	{
		// Here are all of my variables
		//public int GridStepX;
		//public int GridStepY;
		public int XSquares;
		public int YSquares;
		public int XMajor;
		public int YMajor;
		public int Type;
		public int DrawMode;
		public bool Alpha;
		public bool KeepBG;
		public bool Invert;
		public bool UseBrushWidth;
		public bool UseVariation;
		public bool Linked;

		public EffectPluginConfigToken()
			: base()
		{
			// Here are the variable defaults
			//GridStepX = 10;
			//GridStepY = 10;
			XSquares = 10;
			YSquares = 10;
			XMajor = 5;
			YMajor = 5;
			Type = 0;
			DrawMode = 0;
			Alpha = false;
			KeepBG = true;
			Invert = false;
			UseBrushWidth = false;
			UseVariation = false;
			Linked = true;
		}

		protected EffectPluginConfigToken(EffectPluginConfigToken copyMe)
			: base(copyMe)
		{
			//this.GridStepX = copyMe.GridStepX;
			//this.GridStepY = copyMe.GridStepY;
			XSquares = copyMe.XSquares;
			YSquares = copyMe.YSquares;
			XMajor = copyMe.XMajor;
			YMajor = copyMe.YMajor;
			this.Type = copyMe.Type;
			this.DrawMode = copyMe.DrawMode;
			this.Alpha = copyMe.Alpha;
			this.KeepBG = copyMe.KeepBG;
			this.Invert = copyMe.Invert;
			this.UseBrushWidth = copyMe.UseBrushWidth;
			this.UseVariation = copyMe.UseVariation;
			this.Linked = copyMe.Linked;
		}

		public override object Clone()
		{
			return new EffectPluginConfigToken(this);
		}
	}
}